--- zaptel.c.bak	2005-05-15 16:23:07.000000000 +0200
+++ zaptel.c	2005-05-15 16:23:11.000000000 +0200
@@ -461,9 +461,6 @@
 
 	/* In Linux 2.6, this MUST NOT EXECEED 1024 bytes in one read! */
 
-	if (off > 0)
-		return 0;
-
 	span = (long)data;
 
 	if (!span)
@@ -543,15 +540,20 @@
 						if (chans[x]->nextslave && chans[x]->master->channo == x)
 							len += sprintf(page + len, "Master ");
 					}
+				}
+				if ((chans[x]->flags & ZT_FLAG_OPEN)) {
+					len += sprintf(page + len, "(In use) ");
+				}
+				len += sprintf(page + len, "\n");
 			}
-			if ((chans[x]->flags & ZT_FLAG_OPEN)) {
-				len += sprintf(page + len, "(In use) ");
-			}
-			len += sprintf(page + len, "\n");
-
+			if ( len <= off ) /* If everything printed so far is before beginning of request */
+			{
+				off -= len;
+				len = 0;
 			}
 		}
 	}
+	*start = page + off;
 	return len;
 }
 #endif
